(DEFUN c:dhatch	(/		dcl_id	       last_entity
		 select_object	return	       dhobjects
		 retain_boundry	old	       boundry_pt
		 pline_entity	pick_points    userclick
		 pattern_list	#list	       ent_hatch
		)
  (if (/= (entlast) nil)
    (SETQ last_entity (ENTLAST))
  )
  (progn
    (hatch_list)
    (number_list)
    (main_dialog)
    (WHILE (= return T)
      (COND
	((= select_object T)
	 (PROGN	(setq retain_boundry nil)
		(SETQ dhobjects (SSGET))
		(SETQ return nil)
		(SETQ select_object nil)
		(main_dialog)
	 )
	)
	((= pick_points T)
	 (PROGN
	   (IF (= retain_boundry nil)
	     (SETQ old "N")
	     (SETQ old retain_boundry)
	   )				;end of if
	   (INITGET 2 "Yes No")
	   (SETQ retain_boundry (GETKWORD "\nRetain polyline (Yes/No)"))
	   (IF (= retain_boundry nil)
	     (SETQ retain_boundry old)
	   )
	   (princ
	     "\nC to Close or Enter to end pline and press esc to return to window\nDo not press esc to end!!"
	   )
	   (setvar "CMDECHO" 0)
	   (command "._PLINE")
	   (setvar "CMDECHO" 1)
	   (while (= (getvar "CMDACTIVE") 1)
	     (command PAUSE)
	   )(command)

					;end of setq
	   (SETQ dhobjects
		  (ssget "l")
	   )				;end of setq
					;end of if
	   (SETQ return nil)
	   (SETQ pick_points nil)
	   (main_dialog)
	 )				;end of progn
	)
	((= preview T)
	 (PROGN	(if (/= dhobjects nil)
		  (progn
		    (IF	(= dhuser nil)
		      (hatch_predefined)
		      (hatch_user)
		    )
		    (preview_dialog)
		  )
		  (alert "No boundry to hatch")
		)
		(SETQ return nil)
		(SETQ preview nil)
		(IF (= userclick nil)
		  (main_dialog)
		  (IF (/= ent_hatch last_entity)
		    (ENTDEL ent_hatch)
		  )
		)
	 )
	)
      )
    )
    (IF	(= userclick T)
      (PROGN
	(IF (= dhuser nil)
	  (hatch_predefined)
	  (hatch_user)
	)
	(IF (AND (= dhexplode T) (/= last_entity ent_hatch))
	  (COMMAND "explode" ent_hatch)
	  (command)
	)
	(IF (AND (= retain_boundry "No") (/= dhobjects last_entity))
	  (command "erase" dhobjects "")
	  (command)
	)
      )
    )
    (PRIN1)
  )

)
(DEFUN main_dialog ()
  (SETQ	dialogloaded
		     T
	dialogshow
		     T
  )
  (IF (= (GETVAR "hpname") "")
    (SETQ dhname "")
    (SETQ dhname (RTOS (CDR (ASSOC (GETVAR "HPNAME") #list)) 2 0))
  )
  (SETQ ST_NAME (STRCAT "HATCHES(" dhname ")"))
  (SETQ echo (GETVAR "CMDECHO"))
  (SETVAR "CMDECHO" 0)
  ;; Load the dialog box.  Set up error checking to make sure
  ;; that the dialog file is loaded before continuing
  (IF (= -1 (SETQ dcl_id (LOAD_DIALOG "dhatch.dcl")))

    (PROGN
      ;; There's a problem - display a message and set the
      ;; dialogLoaded flag to nil
      (PRINC "\nCannot load dhatch.dcl")
      (SETQ dialogloaded nil)
    ) ;_ end of progn
  ) ;_ end of if
  ;; Load the dynamic_hatch dialog.  If this operation fails, set the
  ;; dialogShow flag to nil.  Note: if there was a problem with
  ;; the load_dialog function above, this will be trapped here
  ;; by including the test for the dialogLoaded flag.
  (IF (AND dialogloaded
	   (NOT (NEW_DIALOG "dynamic_hatch" dcl_id))
      ) ;_ end of and
    (PROGN
      ;; There's a problem...
      (PRINC "\nCannot show dialog dynamic_hatch")
      (SETQ dialogshow nil)
    ) ;_ end of progn
  ) ;_ end of if
  (IF (AND dialogloaded dialogshow)
    (PROGN
      (COND ((= (GETVAR "hpstyle") 0) (SET_TILE "dh_style_s" "1"))
	    ((= (GETVAR "hpstyle") 1) (SET_TILE "dh_style_o" "1"))
	    ((= (GETVAR "hpstyle") 2) (SET_TILE "dh_style_a" "1"))
      )
      (IF (= dhuser nil)
	(PROGN (MODE_TILE "hatch_spacing" 1)
	       (MODE_TILE "c_hatch" 1)
	       (MODE_TILE "pattern_name" 2)
	)
	(PROGN (MODE_TILE "hatch_scale" 1)
	       (MODE_TILE "pattern_name" 1)
	)
      )
      (SETQ x (DIMX_TILE "pattern_img")
	    y (DIMY_TILE "pattern_img")
      )
      (START_IMAGE "pattern_img")
      (SLIDE_IMAGE 0 0 x y (initial_slide))
      (END_IMAGE)
      (IF (= dhexplode T)
	(SET_TILE "explode" "1")
      )
      (IF (= (GETVAR "hpdouble") 1)
	(SET_TILE "c_hatch" "1")
      )
      (SET_TILE "pattern_name" dhname)
      (IF (= dhuser T)
	(SET_TILE "user_define" "1")
      )
      (SET_TILE	"hatch_scale"
		(RTOS (SETQ dhscale (GETVAR "HPSCALE")) 2 2)
      )
      (SET_TILE	"hatch_angle"
		(RTOS (SETQ dhanlge (radians->degrees (GETVAR "HPANG")))
		      2
		      2
		)
      )
      (SET_TILE	"hatch_spacing"
		(RTOS (SETQ dhspacing (GETVAR "HPspace")) 2 2)
      )
      (ACTION_TILE
	"pattern_name"
	(STRCAT	"(progn (setq pat_no (get_tile \"pattern_name\"))"
		"(START_IMAGE \"pattern_img\")"
		"(FILL_IMAGE 0 0 x y -2)"
		"(SLIDE_IMAGE 0 0 x y (show_slide))"
		"(END_IMAGE))"
	)
      )
      (ACTION_TILE
	"user_define"
	(STRCAT
	  "(if (= dhuser nil)"
	  "(progn"
	  "(setq dhuser t)"
	  "(mode_tile \"hatch_spacing\" 0)(mode_tile \"c_hatch\" 0)"
	  "(mode_tile \"hatch_scale\" 1)(mode_tile \"pattern_name\" 1))"
	  "(progn"
	  "(setq dhuser nil)"
	  "(mode_tile \"hatch_spacing\" 1)(mode_tile \"c_hatch\" 1)"
	  "(mode_tile \"hatch_scale\" 0)(mode_tile \"pattern_name\" 0)))"
	 )
      )
      (ACTION_TILE
	"c_hatch"
	"(if (= (getvar \"HPDOUBLE\") 0)(setvar \"HPDouble\" 1)(setvar \"HPDouble\" 0))"
      )
      (ACTION_TILE
	"pick_bound"
	(STRCAT
	  "(progn (setvar \"hpname\" (cdr (assoc (atoi (get_tile \"pattern_name\")) pattern_list)))"
	  "(setvar \"hpscale\" (atof (get_tile \"hatch_scale\")))"
	  "(setvar \"hpang\" (degrees->radians (atof (get_tile \"hatch_angle\"))))"
	  "(done_dialog) (setq return T)(setq pick_points T))"
	)
      )
      (ACTION_TILE
	"select"
	(STRCAT
	  "(progn (setvar \"hpname\" (cdr (assoc (atoi (get_tile \"pattern_name\")) pattern_list)))"
	  "(setvar \"hpscale\" (atof (get_tile \"hatch_scale\")))"
	  "(setvar \"hpang\" (degrees->radians (atof (get_tile \"hatch_angle\"))))"
	  "(done_dialog) (setq return T)(setq select_object T))"
	)
      )
      (ACTION_TILE
	"dh_style_s"
	"(setvar \"hpstyle\" 0)"
      )
      (ACTION_TILE
	"dh_style_o"
	"(setvar \"hpstyle\" 1)"
      )
      (ACTION_TILE
	"dh_style_a"
	"(setvar \"hpstyle\" 2)"
      )
      (ACTION_TILE
	"explode"
	"(if (= dhexplode nil)(setq DHexplode T)(setq dhexplode nil))"
      )
      (ACTION_TILE
	"preview"
	(STRCAT
	  "(progn (setvar \"hpname\" (cdr (assoc (atoi (get_tile \"pattern_name\")) pattern_list)))"
	  "(setvar \"hpscale\" (atof (get_tile \"hatch_scale\")))"
	  "(setvar \"hpang\" (degrees->radians (atof (get_tile \"hatch_angle\"))))"
	  "(setvar \"hpspace\" (atof (get_tile \"hatch_spacing\")))"
	  "(done_dialog)(setq return T)(setq preview T))"
	)
      )
      (ACTION_TILE
	"cancel"
	"(done_dialog) (setq UserClick nil)"
      )
      (ACTION_TILE
	"accept"
	(STRCAT
	  "(progn (setvar \"hpname\" (cdr (assoc (atoi (get_tile \"pattern_name\")) pattern_list)))"
	  "(setvar \"hpscale\" (atof (get_tile \"hatch_scale\")))"
	  "(setvar \"hpang\" (degrees->radians (atof (get_tile \"hatch_angle\"))))(setq return nil)"
	  "(setvar \"hpspace\" (atof (get_tile \"hatch_spacing\")))"
	  "(done_dialog) (setq UserClick T))"
	)
      )
    )

  )
  (START_DIALOG)
  (UNLOAD_DIALOG dcl_id)
)
(DEFUN preview_dialog ()
  (SETQ	dialogloaded
		     T
	dialogshow
		     T
  )

  (IF (= (GETVAR "hpname") "")
    (SETQ dhname "")
    (SETQ dhname (RTOS (CDR (ASSOC (GETVAR "HPNAME") #list))))
  )
  (SETQ echo (GETVAR "CMDECHO"))
  (SETVAR "CMDECHO" 0)
  ;; Load the dialog box.  Set up error checking to make sure
  ;; that the dialog file is loaded before continuing
  (IF (= -1 (SETQ dcl_id (LOAD_DIALOG "dhatch.dcl")))

    (PROGN
      ;; There's a problem - display a message and set the
      ;; dialogLoaded flag to nil
      (PRINC "\nCannot load dhatch.dcl")
      (SETQ dialogloaded nil)
    ) ;_ end of progn
  ) ;_ end of if
  ;; Load the preview_hatch dialog.  If this operation fails, set the
  ;; dialogShow flag to nil.  Note: if there was a problem with
  ;; the load_dialog function above, this will be trapped here
  ;; by including the test for the dialogLoaded flag.
  (IF (AND dialogloaded
	   (NOT (NEW_DIALOG "preview_hatch" dcl_id))
      ) ;_ end of and
    (PROGN
      ;; There's a problem...
      (PRINC "\nCannot show dialog preview_hatch")
      (SETQ dialogshow nil)
    ) ;_ end of progn
  ) ;_ end of if
  (IF (AND dialogloaded dialogshow)
    (PROGN
      (ACTION_TILE
	"accept"
	"(done_dialog)(progn (setq preview nil)(setq UserClick T))"
      )
      (ACTION_TILE
	"cancel"
	"(if (/= ent_hatch last_entity)(entdel ent_hatch))(done_dialog)(setq UserClick nil)"
      )
    )
  )
  (START_DIALOG)
  (UNLOAD_DIALOG dcl_id)
)
(DEFUN hatch_list ()
  (SETQ	pattern_list
	 (LIST
	   (CONS 0 "ANSI31")
	   (CONS 1 "ANSI32")
	   (CONS 2 "ANSI33")
	   (CONS 3 "ANSI34")
	   (CONS 4 "ANSI35")
	   (CONS 5 "ANSI36")
	   (CONS 6 "ANSI37")
	   (CONS 7 "ANSI38")
	   (CONS 8 "2X2BRIKC")
	   (CONS 9 "2X2BRIKS")
	   (CONS 10 "ANCHORLK")
	   (CONS 11 "APPIAN2")
	   (CONS 12 "APPIANRN")
	   (CONS 13 "ASPHALT")
	   (CONS 14 "BOARD")
	   (CONS 15 "BOARDW")
	   (CONS 16 "BOARDWN")
	   (CONS 17 "CHECKERED")
	   (CONS 18 "CONC")
	   (CONS 19 "CONCRE")
	   (CONS 20 "CROSS")
	   (CONS 21 "CTYSQ6RN")
	   (CONS 22 "CTYSQ6ST")
	   (CONS 23 "CTYSQMK1")
	   (CONS 24 "CTYSQMK2")
	   (CONS 25 "CTYSQRN")
	   (CONS 26 "CTYSQST")
	   (CONS 27 "DBLHLNRN")
	   (CONS 28 "DBLHLNST")
	   (CONS 29 "DELTA")
	   (CONS 30 "DIAMONDS")
	   (CONS 31 "EARTH2")
	   (CONS 32 "EGYPT")
	   (CONS 33 "FBBRICKC")
	   (CONS 34 "FBBRICKS")
	   (CONS 35 "FINETTA")
	   (CONS 36 "GLASS")
	   (CONS 37 "GLB")
	   (CONS 38 "GRAVL1")
	   (CONS 39 "GROUT")
	   (CONS 40 "HLNBSK")
	   (CONS 41 "HLNHER")
	   (CONS 42 "HLNIST")
	   (CONS 43 "HLNPARQ")
	   (CONS 44 "HLNRN")
	   (CONS 45 "HLNST")
	   (CONS 46 "MBLOCKC")
	   (CONS 47 "MBLOCKS")
	   (CONS 48 "MRBLOCKC")
	   (CONS 49 "MRBLOCKS")
	   (CONS 50 "MSBLOCKC")
	   (CONS 51 "MSBLOCKS")
	   (CONS 52 "OCTAGON")
	   (CONS 53 "PLUS")
	   (CONS 54 "RBBRICKC")
	   (CONS 55 "RBBRICKS")
	   (CONS 56 "SBBRICKC")
	   (CONS 57 "SBBRICKS")
	   (CONS 58 "SCREEN")
	   (CONS 59 "SHAKES1")
	   (CONS 60 "SHAKES2")
	   (CONS 61 "SHINGLE1")
	   (CONS 62 "SPANTILE")
	   (CONS 63 "SQDOTS")
	   (CONS 64 "STIPPLE")
	   (CONS 65 "SUPERDCR")
	   (CONS 66 "TES36")
	   (CONS 67 "THREAD")
	   (CONS 68 "TRIDOTS")
	   (CONS 69 "TURFSTNE")
	   (CONS 70 "UNIDECOR")
	   (CONS 71 "UNIHER")
	   (CONS 72 "UNIPARQ")
	   (CONS 73 "UNIRN")
	   (CONS 74 "WAFFLE")
	   (CONS 75 "WATER")
	   (CONS 76 "WOOD1")
	   (CONS 77 "WOOD2")
	   (CONS 78 "WOOD3")
	   (CONS 79 "WOOD4")
	   (CONS 80 "WOOD8")
	   (CONS 81 "ZIGZAG")
	 )
  )
)
(DEFUN number_list ()
  (SETQ	#list (LIST
		(CONS "ANSI31" 0)
		(CONS "ANSI32" 1)
		(CONS "ANSI33" 2)
		(CONS "ANSI34" 3)
		(CONS "ANSI35" 4)
		(CONS "ANSI36" 5)
		(CONS "ANSI37" 6)
		(CONS "ANSI38" 7)
		(CONS "2X2BRIKC" 8)
		(CONS "2X2BRIKS" 9)
		(CONS "ANCHORLK" 10)
		(CONS "APPIAN2" 11)
		(CONS "APPIANRN" 12)
		(CONS "ASPHALT" 13)
		(CONS "BOARD" 14)
		(CONS "BOARDW" 15)
		(CONS "BOARDWN" 16)
		(CONS "CHECKERED" 17)
		(CONS "CONC" 18)
		(CONS "CONCRE" 19)
		(CONS "CROSS" 20)
		(CONS "CTYSQ6RN" 21)
		(CONS "CTYSQ6ST" 22)
		(CONS "CTYSQMK1" 23)
		(CONS "CTYSQMK2" 24)
		(CONS "CTYSQRN" 25)
		(CONS "CTYSQST" 26)
		(CONS "DBLHLNRN" 27)
		(CONS "DBLHLNST" 28)
		(CONS "DELTA" 29)
		(CONS "DIAMONDS" 30)
		(CONS "EARTH2" 31)
		(CONS "EGYPT" 32)
		(CONS "FBBRICKC" 33)
		(CONS "FBBRICKS" 34)
		(CONS "FINETTA" 35)
		(CONS "GLASS" 36)
		(CONS "GLB" 37)
		(CONS "GRAVL1" 38)
		(CONS "GROUT" 39)
		(CONS "HLNBSK" 40)
		(CONS "HLNHER" 41)
		(CONS "HLNIST" 42)
		(CONS "HLNPARQ" 43)
		(CONS "HLNRN" 44)
		(CONS "HLNST" 45)
		(CONS "MBLOCKC" 46)
		(CONS "MBLOCKS" 47)
		(CONS "MRBLOCKC" 48)
		(CONS "MRBLOCKS" 49)
		(CONS "MSBLOCKC" 50)
		(CONS "MSBLOCKS" 51)
		(CONS "OCTAGON" 52)
		(CONS "PLUS" 53)
		(CONS "RBBRICKC" 54)
		(CONS "RBBRICKS" 55)
		(CONS "SBBRICKC" 56)
		(CONS "SBBRICKS" 57)
		(CONS "SCREEN" 58)
		(CONS "SHAKES1" 59)
		(CONS "SHAKES2" 60)
		(CONS "SHINGLE1" 61)
		(CONS "SPANTILE" 62)
		(CONS "SQDOTS" 63)
		(CONS "STIPPLE" 64)
		(CONS "SUPERDCR" 65)
		(CONS "TES36" 66)
		(CONS "THREAD" 67)
		(CONS "TRIDOTS" 68)
		(CONS "TURFSTNE" 69)
		(CONS "UNIDECOR" 70)
		(CONS "UNIHER" 71)
		(CONS "UNIPARQ" 72)
		(CONS "UNIRN" 73)
		(CONS "WAFFLE" 74)
		(CONS "WATER" 75)
		(CONS "WOOD1" 76)
		(CONS "WOOD2" 77)
		(CONS "WOOD3" 80)
		(CONS "WOOD4" 81)
		(CONS "WOOD8" 82)
		(CONS "ZIGZAG" 83)
	      )
  )
)
(DEFUN hatch_predefined	()
  (if (/= dhobjects nil)
    (PROGN (COMMAND "hatch" "" "" "" dhobjects "")
	   (SETQ ent_hatch (ENTLAST))
    )

  )
)
(DEFUN hatch_user ()
  (if (/= dhobjects nil)
    (PROGN (SETVAR "hpname" "")
	   (COMMAND "hatch" "" "" "" "" dhobjects "")
	   (SETQ ent_hatch (ENTLAST))
    )

  )
)

(DEFUN degrees->radians	(numberofdegrees)
  (* PI (/ numberofdegrees 180.0))
) ;_ end of defun

(DEFUN radians->degrees	(numberofradians)
  (* 180.0 (/ numberofradians PI))
) ;_ end of defun

(princ
  "\tDynamic Hatch 1.1 by David Trotz Jr. 3/31/99. Type DHATCH or DH to run."
)
(princ)