dynamic_hatch : dialog {
  label = "Dynamic Hatch for IntelliCAD 98";
: column {
  : row {
    : column {
      : boxed_column {
        label = "Pattern T&ype";
	: image_button {
            color        = -2;
            width        = 16;
            aspect_ratio = 0.60;
            allow_accept = true;
            fixed_height = true;
            fixed_width  = true;
            alignment    = right;
            key = "pattern_img";
            allow_accept = false;
        }
	: popup_list {
            label = "Patter&n:";
            width = 20;
            key = "pattern_name";
            list = "ANSI31\nANSI32\nANSI33\nANSI34\nANSI35\nANSI36\nANSI37\nANSI38\n2X2BRIKC\n2X2BRIKS\nANCHORLK\nAPPIAN2\nAPPIANRN\nASPHALT\nBOARD\nBOARDW\nBOARDWN\nCHECKERED\nCONC\nCONCRE\nCROSS\nCTYSQ6RN\nCTYSQ6ST\nCTYSQMK1\nCTYSQMK2\nCTYSQRN\nCTYSQST\nDBLHLNRN\nDBLHLNST\nDELTA\nDIAMONDS\nEARTH2\nEGYPT\nFBBRICKC\nFBBRICKS\nFINETTA\nGLASS\nGLB\nGRAVL1\nGROUT\nHLNBSK\nHLNHER\nHLNIST\nHLNPARQ\nHLNRN\nHLNST\nMBLOCKC\nMBLOCKS\nMRBLOCKC\nMRBLOCKS\nMSBLOCKC\nMSBLOCKS\nOCTAGON\nPLUS\nRBBRICKC\nRBBRICKS\nSBBRICKC\nSBBRICKS\nSCREEN\nSHAKES1\nSHAKES2\nSHINGLE1\nSPANTILE\nSQDOTS\nSTIPPLE\nSUPERDCR\nTES36\nTHREAD\nTRIDOTS\nTURFSTNE\nUNIDECOR\nUNIHER\nUNIPARQ\nUNIRN\nWAFFLE\nWATER\nWOOD1\nWOOD2\nWOOD3\nWOOD4\nWOOD8\nZIGZAG\n";
              
	}
	: spacer {}
      : toggle {
	label = "&User-Defined";
	key = "user_define";
      
	}	
	}
      : boxed_row {
        label = "Pattern Properties";
        : column {
          : edit_box {
            alignment = left;
	    label = "Sca&le:   ";
            key = "hatch_scale";
            edit_width = 12;
          }
          : edit_box {
            label = "&Angle:    ";
            alignment = left;
	    edit_width = 12;
            key = "hatch_angle";
          }
	  : edit_box {
            label = "&Spacing:";
            alignment = left;
	    key = "hatch_spacing";
            edit_width = 12;
          }
	  : spacer {}
          : toggle {
            label = "&Cross Hatching";
            key = "c_hatch";
          }
        }
      }
    }
    : column {
      children_width = 18;
      children_fixed_width = true;
      children_alignment = centered;
      : boxed_column {
        label = "Boundary";
        
	: button {
          label = "Pick &Points <";
          key = "pick_area";
        }
        : button {
          label = "Pick &Boundry <";
          key = "pick_bound";
        }
        : button {
          label = "Select &Objects <";
          key = "select";
        }
              }
      :boxed_radio_column {
	label = "Pattern Style";
	width = 18;
	:radio_button {
	label = "Standard";
	key = "dh_style_s";
}
:radio_button {
	label = "Outer";
	key = "dh_style_o";
}
:radio_button {
	label = "All";
	key = "dh_style_a";
}
}
      : column {
	: boxed_column {
          label = "Attributes";
          width = 18;
	: toggle {
            label = "&Exploded";
            key = "explode";
          }}
	
        : spacer {}
        : button {
          label = "Preview Ha&tch <";
          key = "preview";
          width = 18;
        }
               }
     
    }
  }
  : row {
    fixed_width = true;
    alignment = centered;
    
    : button {
      key = "accept";
      is_default = true;
      label = "Apply";
      width = 8;
    }
    
    : button {
      key = "cancel";
      label = "Cancel";
      width = 8;
      is_cancel = true;
    }
    
    
  }
 }
:text {
label = " David Trotz 1999";
}
}

preview_hatch : dialog {
		label = "Preview Hatch";	
  : row {
  : button {
      	key = "accept";
      	is_default = true;
      	label = "Apply";
      	width = 8;
    }
    
  	: button {
      	key = "cancel";
      	label = "Change";
      	width = 8;
      	is_cancel = true;
    }
}
}